#ifndef _IO_h_
#define _IO_h_

#include "util.h"

typedef enum
{
	KEY=0,
	MOD
} generic_key_types;

struct generic_key
{
	int					code;
	generic_key_types	type;
};

struct complete_key
{
	SDLKey key;
	SDLMod mod;
};

struct mouse_status
{
	int		x;
	int		y;
	int		old_x;
	int		old_y;
	Uint8	buttons;
	int		button_x;
	int		button_y;
	Uint8	old_buttons;
	ptr		pointer;
};

void IO_init(void);
void IO_reset(void);
void IO_flush(void);

void IO_mouse_init(void);
void IO_mouse_reset(void);
void IO_mouse_buttons_release(void);
void IO_mouse_get_status(SDL_MouseMotionEvent* event);
void IO_mouse_get_button_status(SDL_MouseButtonEvent* event);
bool IO_mouse_in_box(int x, int y, int width, int height);
bool IO_mouse_clicked_in_box(int button_mask, int x, int y, int width, int height);
bool IO_mouse_click_in_box(int x, int y, int width, int height);
bool IO_mouse_clicked(int button_mask);
bool IO_mouse_has_moved(void);
void IO_mouse_set_pointer(ptr pointer);

void IO_key_init(void);
void IO_key_reset(void);
void IO_key_release(void);
void IO_key_get_status(void);
bool IO_complete_key_pressed(struct complete_key compkey);
bool IO_keymod_pressed(SDLKey key, SDLMod mod);
bool IO_genkey_pressed(struct generic_key genkey);
bool IO_key_pressed(SDLKey key);
bool IO_mod_pressed(SDLMod mod);
void IO_key_event(void);

void IO_unsupported_event(SDL_Event* event);
void IO_flush_events(void);
bool IO_wait_until_event_or_time(Uint32 milliseconds);

#endif
