#include "intro.h"
#include "util.h"
#include "gfx.h"
#include "core.h"
#include "IO.h"


extern SDL_Surface*	screen;


void intro_init(void)
{
	info("intro", "starting module init..");

	IO_flush_events();
	
	info("intro", "module init completed");
}

void intro_reset(void)
{
	info("intro", "starting module reset..");


	info("intro", "module reset completed");
}

void intro_play(void)
{
	SDL_Surface*	data;
	intro_stages	stage;
	gfx_resources	rsc;
	
	info("intro", "playing intro..");

	stage=INTRO_LOGO;	
	while (stage!=INTRO_DONE)
	{
		switch (stage)
		{
			case INTRO_LOGO:
				info("intro", "showing logo..");

				rsc=RSC_LOGO;
				gfx_load_palette(rsc);

				data=gfx_get_resource_buffer(rsc);
				gfx_blit(data, 0, 0, gfx_get_resource_width(rsc),
						gfx_get_resource_height(rsc), screen, 0, 0);

				if (gfx_fade_in(500))
					stage=INTRO_DONE;
				else
					if (IO_wait_until_event_or_time(1000))
						stage=INTRO_DONE;
					else
						if (gfx_fade_out(250))
							stage=INTRO_DONE;
						else
							stage=INTRO_TITLE;
				break;

			case INTRO_TITLE:
				info("intro", "showing title..");

				rsc=RSC_TITLE;
				gfx_load_palette(rsc);
				data=gfx_get_resource_buffer(rsc);

				gfx_blit(data, 0, 0, gfx_get_resource_width(rsc),
						gfx_get_resource_height(rsc), screen, 0, 0);

				if (NOT(gfx_fade_in(1000)))
					if (NOT(IO_wait_until_event_or_time(1500)))
						gfx_fade_out(500);
				stage=INTRO_DONE;
				break;

			default:
				NOP
		}
		gfx_clear(screen);
		gfx_flush();
	}
	info("intro", "intro played..");
}
