#include "menu.h"
#include "gfx.h"
#include "core.h"
#include "IO.h"
#include "game.h"

extern SDL_Surface*			screen;
extern bool					redraw;
/*extern struct mouse_status mouse;
extern struct video_options video_conf;*/


/****************************************************************************/
/*								MAIN MENU MANAGEMENT						*/
/****************************************************************************/


void menu_init(void)
{
	info("menu", "starting module init..");

	IO_flush_events();

	info("menu", "module init completed");
}

void menu_reset(void)
{
	info("menu", "starting module reset..");

	info("menu", "module reset completed");
}

void menu_enter_the_game(void)
{
	gfx_clear(screen);
	gfx_flush();

	/* TODO: anim: open the main door */

	push_game_handler(GHANDLER_GAME);
}

void menu_event_handler(SDL_Event* IO_event)
{
/*	if (get_current_game_handler()!=GHANDLER_MENU)
		return;
*/	
	if (IO_event)
		switch (IO_event->type)
		{
			case SDL_KEYDOWN:	/* keys */
				if (IO_keymod_pressed(SDLK_ESCAPE, KMOD_NONE))
				{
					gfx_clear(screen);
					gfx_flush();
					pop_game_handler();
					return;
				}
				else
				if (IO_keymod_pressed(SDLK_RETURN, KMOD_NONE))
					menu_enter_the_game();
				else
				if (IO_keymod_pressed(SDLK_KP_ENTER, KMOD_NONE))
					menu_enter_the_game();
				break;

			case SDL_MOUSEBUTTONDOWN:	/* mouse click */
				if (IO_mouse_clicked(SDL_BUTTON(SDL_BUTTON_LEFT)))
				{
					/* TODO: manage left click */
					if (IO_mouse_click_in_box(245, 44, 11, 13))
						menu_enter_the_game();
					/* redraw=true; */
					IO_mouse_buttons_release();
				}
				else
				if (IO_mouse_clicked(SDL_BUTTON(SDL_BUTTON_RIGHT)))
				{
					/* TODO: manage left click */
					/* redraw=true; */
					IO_mouse_buttons_release();
				}
				break;

			case SDL_MOUSEMOTION:	/* mouse motion */
				if (IO_mouse_has_moved())
				{
/*printf("(%d, %d)\n", mouse.x/video_conf.multiplier, mouse.y/video_conf.multiplier);*/
					/* TODO: set mouse pointer according to its position */
					IO_mouse_set_pointer(NULL);

					/* TODO: activate background parts according to the mouse position */

					/*redraw=true;*/
				}
				break;

			default:
				NOP
		}
}


/****************************************************************************/
/*							CREDITS DISPLAY SEQUENCE						*/
/****************************************************************************/


void credits_display(void)
{
	SDL_Surface*	data;
	gfx_resources	rsc;

	info("credits", "displaying credits..");

	rsc=RSC_CREDITS;
	gfx_load_palette(rsc);

	data=gfx_get_resource_buffer(rsc);
	gfx_blit(data, 0, 0, gfx_get_resource_width(rsc),
			gfx_get_resource_height(rsc), screen, 0, 0);

	if (NOT(gfx_fade_in(1000)))
		if (NOT(IO_wait_until_event_or_time(5000)))
			gfx_fade_out(500);

	gfx_clear(screen);
	gfx_flush();

	info("credits", "credits displayed");
}

void credits_init(void)
{
	info("credits", "starting module init..");

	IO_flush_events();

	/* set palette */
	gfx_load_palette(RSC_CREDITS);

	info("credits", "module init completed");
}

void credits_reset(void)
{
	info("credits", "starting module reset..");


	info("credits", "module reset completed");
}
